openfoam/wmake/wmakeLnInclude
Mark Olesen 3d98c3d593 ENH: add -root option for wmakeLnInclude (convenience)
- finds the correct root directory location before creating
  the lnInclude directory

  Eg,

  from within something like src/finiteVolume/fields/fvPatchFields/..

      wmakeLnInclude -update -root

  it backtracks to find the top-level directory with Make/
  and makes the lnInclude directory there:

    Using /home/mark/openfoam/OpenFOAM-plus/src/finiteVolume
        ln: /home/mark/openfoam/OpenFOAM-plus/src/finiteVolume/lnInclude
2019-01-25 16:20:58 +01:00

214 lines
5.4 KiB
Bash
Executable File

#!/bin/sh
#------------------------------------------------------------------------------
# ========= |
# \\ / F ield | OpenFOAM: The Open Source CFD Toolbox
# \\ / O peration |
# \\ / A nd | Copyright (C) 2011-2016 OpenFOAM Foundation
# \\/ M anipulation | Copyright (C) 2019 OpenCFD Ltd.
#-------------------------------------------------------------------------------
# License
# This file is part of OpenFOAM.
#
# OpenFOAM is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License
# along with OpenFOAM. If not, see <http://www.gnu.org/licenses/>.
#
# Script
# wmakeLnInclude
#
# Usage
# wmakeLnInclude [OPTION] [-root | <dir>]
#
# Description
# Link all the source files in the <dir> directory into <dir>/lnInclude
#
# The desired source files:
# *.C *.H *.h *.cpp *.cxx *.hpp *.hxx
#
# Avoid
# *.c (C source)
#
#------------------------------------------------------------------------------
Script="${0##*/}" # Use 'Script' for error messages in wmakeFunctions
. "${0%/*}/scripts/wmakeFunctions" # Source wmake functions
usage() {
exec 1>&2
while [ "$#" -ge 1 ]; do echo "$1"; shift; done
cat<<USAGE
Usage: $Script [OPTION] [-root | dir]
options:
-u | -update Update
-s | -silent Use 'silent' mode (do not echo command)
-root Locate root directory containing a Make/ directory.
-h | -help Print the usage
Link all the source files in the <dir> into <dir>/lnInclude
Note
The '-u' option forces an update when the lnInclude directory already exists
and changes the default linking from 'ln -s' to 'ln -sf'.
USAGE
exit 1
}
#------------------------------------------------------------------------------
# Parse arguments and options
#------------------------------------------------------------------------------
# Option for 'ln'
optLink="-s"
unset update optQuiet optRoot
while [ "$#" -gt 0 ]
do
case "$1" in
-h | -help*) # Provide immediate help
usage
;;
-u | -update)
update=true
optLink="-sf"
;;
-s | -silent)
optQuiet=true
;;
-root)
optRoot=true
;;
-*)
usage "unknown option: '$1'"
;;
*)
break
;;
esac
shift
done
[ "$optRoot" = true ] || [ "$#" -eq 1 ] || \
usage "Error: incorrect number of arguments"
#------------------------------------------------------------------------------
unset dir
baseDir="$1"
# With -root, go on discovery
if [ "$optRoot" = true ]
then
if [ -n "$baseDir" ]
then
dir="$baseDir"
if [ -d "$dir" ]
then
dir="${dir%/}"
elif [ -f "$dir" ]
then
dir="${dir%/*}"
: "${dir:=.}"
else
echo "$Script error: not a file or directory" 1>&2
exit 1
fi
cd "$dir" 2>/dev/null || {
echo "$Script error: could not change to directory '$dir'" 1>&2
exit 1
}
fi
# Locate target with Make/ directory
if dir="$(findTarget .)"
then
baseDir="$(cd "$dir" && pwd -L)"
else
exit 2
fi
echo "Using $baseDir" 1>&2
fi
# Convert incorrect path/dir/lnInclude to something sensible
while [ "${baseDir##*/}" = lnInclude ]
do
baseDir="${baseDir%/*}"
if [ "$baseDir" = lnInclude ]
then
baseDir="."
fi
done
incDir="$baseDir/lnInclude"
[ -d "$baseDir" ] || {
echo "$Script error: base directory $baseDir does not exist" 1>&2
exit 2
}
if [ -d "$incDir" ]
then
[ "$update" = true ] || exit 0
else
mkdir "$incDir"
fi
[ -d "$incDir" ] || {
echo "$Script error: failed to create include directory $incDir" 1>&2
exit 0
}
cd "$incDir" || exit 1
# Always just display compact info
echo " ln: $incDir" 1>&2
#------------------------------------------------------------------------------
# Remove any broken links first (this helps when file locations have moved)
#------------------------------------------------------------------------------
case "$WM_ARCH" in
(darwin*)
find -L . -type l -exec rm -- {} \+
;;
(*)
find -L . -type l -delete
;;
esac
#------------------------------------------------------------------------------
# Create links, avoid recreating links unless necessary
# things placed in the 'noLink' directory are skipped
#------------------------------------------------------------------------------
find .. \
\( -name lnInclude -o -name Make -o -name config -o -name noLink \) \
-prune \
-o \( \
-name '*.[CHh]' \
-o -name '*.[ch]xx' \
-o -name '*.[ch]pp' \
-o -name '*.type' \
\) \
-exec ln "$optLink" {} . \;
exit 0 # clean exit
#------------------------------------------------------------------------------